/*------------------------------------------------------------------------------
#
#	MenuHack code, uses GNEFilter to hack into Netscape from one app to another.
#
#	MHHandler.c	-	Handle the clicks, draw, etc.
#
#	Copyright  CE Software, Inc., Inc. 1996
#	All rights reserved.
#
------------------------------------------------------------------------------*/

#include "MenuHackData.h"
#include <PLStringFuncs.h>
#include <Folders.h>
#include <string.h>
#include <TextServices.h>
#include "ICAPI.h"	// Internet config stuff
#include "jGNELib.h"

typedef pascal long (*MKCaller)(short ch);
typedef pascal long (*MSCaller)(Point startpoint);

typedef struct {
	OSType		gBrowserCreator;
	Boolean		gIHavePatched;
	Boolean		gTimeToBuildMenu;
	short		mymenuID;
	MKCaller	SavedMenuKey;
	MSCaller	SavedMenuSelect;
	
	long		numberofitems;
	long		whichitem;
	Str255		sURL;
	Str255		sTitle;
	Str255		sComment;
	Boolean		TimeToRun;
	
	} sGullData, *sGullDataPtr, **sGullDataHdl;

sGullData	theglobals;
sGullDataPtr	gOurGlobals = nil;


ICInstance ginst;

pascal Boolean	CalledHandleAnEvent(EventRecord* event, sGullDataPtr	gGlobalsPtr);
void GetURLInfo(sGullDataPtr	gGlobalsPtr);

static Boolean LaunchedApplication(FSSpec *fsSpec,
								ProcessSerialNumber *processSerialNumber) 				// <-
	// We return true and the launched app's process serial number
	// if the launch was successful.
	// Notice that we call EventAvail() once; this causes the application
	// to actually run before we return.
	{
	OSErr					error;
	LaunchParamBlockRec	launchPB;
	EventRecord 			ignoreMacEvent;
	
	memset((Byte*)&launchPB, 0, sizeof(launchPB));

	launchPB.launchBlockID = extendedBlock;
	launchPB.launchEPBLength = extendedBlockLen;
	launchPB.launchFileFlags = launchNoFileFlags;
	launchPB.launchControlFlags = launchContinue | launchNoFileFlags | launchUseMinimum;
	launchPB.launchAppSpec = fsSpec;
	launchPB.launchAppParameters = nil;
	error = LaunchApplication((LaunchPBPtr)&launchPB);
	
	if (!error)
		{
		EventAvail(everyEvent, &ignoreMacEvent);		// We do this so the app is actually running before we return.
		*processSerialNumber = launchPB.launchProcessSN;
		}
		
	return error == noErr;
	}
	
	

static Boolean LaunchApplicationInSameDirectory( OSType ostCreator, ProcessSerialNumber *processSerialNumber )
{
	Boolean fResult = false;
	FSSpec	fsSpec;

	FCBPBRec sPB;
	memset((Byte*)&sPB, 0x00, sizeof(FCBPBRec));
	
	sPB.ioNamePtr = (StringPtr)&fsSpec.name;
	sPB.ioRefNum = CurResFile();
	
	if ( PBGetFCBInfo( &sPB, false ) == noErr )
	{
		CInfoPBRec	cPB;
		OSErr		oseErr;
		Str255		pasFileName;
		Boolean		fFound = false;

		memset((Byte*)&cPB, 0x00, sizeof(FCBPBRec));

		cPB.hFileInfo.ioNamePtr = pasFileName;
		cPB.hFileInfo.ioVRefNum = sPB.ioFCBVRefNum;
		cPB.hFileInfo.ioDirID = sPB.ioFCBParID;

		do {
			cPB.hFileInfo.ioDirID = sPB.ioFCBParID;
			cPB.hFileInfo.ioFDirIndex++;
			oseErr = PBGetCatInfo( &cPB, false );
			if ( oseErr == noErr )
				fFound =	( cPB.hFileInfo.ioFlFndrInfo.fdType == 'APPL' ) &&
							( cPB.hFileInfo.ioFlFndrInfo.fdCreator == ostCreator );

		} while ( !fFound && ( oseErr == noErr ) );
		
		if ( fFound )
		{
			fsSpec.vRefNum = sPB.ioFCBVRefNum;
			fsSpec.parID = sPB.ioFCBParID;
			BlockMove( pasFileName, fsSpec.name, pasFileName[0] + 1 );

			fResult = LaunchedApplication( &fsSpec, processSerialNumber );
		}
	}

	return fResult;
}
	

static Boolean LaunchAppBySig( OSType ostCreator, ProcessSerialNumber *processSerialNumber )
{
	Boolean fResult = false;
	Boolean	fFound = false;
	FSSpec	fsSpec;

	DTPBRec	sdPB;
	short	refnum;
	OSErr		anErr = noErr;
	Str255		pasFileName;
	
	HParamBlockRec hpb;
	short		vindex = 0;
	
	memset((Byte*)&hpb, 0x00, sizeof(HParamBlockRec));
	do
	{
		vindex++;
		hpb.volumeParam.ioNamePtr = nil;
		hpb.volumeParam.ioVolIndex = vindex;
		anErr = PBHGetVInfo(&hpb, false);
		if (anErr==noErr)
		{
			memset((Byte*)&sdPB, 0x00, sizeof(DTPBRec));
			
			sdPB.ioNamePtr = nil;
			sdPB.ioVRefNum = hpb.volumeParam.ioVRefNum;
			
			if ( PBDTGetPath( &sdPB ) == noErr )
			{
				refnum = sdPB.ioDTRefNum;
				sdPB.ioNamePtr = pasFileName;
				pasFileName[0] = 0;
				sdPB.ioIndex = 0;
				sdPB.ioFileCreator = ostCreator;
				
				if (PBDTGetAPPL( &sdPB, false) == noErr)
				{
					fsSpec.vRefNum = hpb.volumeParam.ioVRefNum;
					fsSpec.parID = sdPB.ioAPPLParID;
					BlockMove( pasFileName, fsSpec.name, pasFileName[0] + 1 );
		
					fFound = LaunchedApplication( &fsSpec, processSerialNumber );
				}
			}
		}
	}
	while ( !fFound && ( anErr == noErr ) );

	return fResult;
}

static void ClipNetscapeName(Str255 thestr)
{
	Str255 tempstr;
	Str31  NetName = "\pNetscape: ";
	short	oldlength = thestr[0];
	Boolean	gotaMatch;
	short	i;
	
	if (oldlength<=NetName[0])  // if too short, not possible it starts with Netscape
	{
		return;
	}
	thestr[0]=NetName[0];
	gotaMatch = EqualString(thestr, NetName, false, false);
	thestr[0] = oldlength;
	if (gotaMatch)
	{
		oldlength = oldlength - NetName[0];
		thestr[0] = oldlength;
		for (i = 1; i <= oldlength; i++)
		{
			thestr[i] = thestr[i+NetName[0]];
		}
	}
	
}
	

static OSType GetFrontSignature( void )
{
	ProcessSerialNumber thepsn;
	ProcessInfoRec	info;
	OSErr	anErr;
	
	anErr = GetFrontProcess(&thepsn);
	info.processInfoLength = sizeof(info);
	info.processName = nil;
	info.processAppSpec = nil;
	anErr = GetProcessInformation(&thepsn, &info);
	return info.processSignature;
}

static OSType GetCurrentSignature( void )
{
	ProcessSerialNumber thepsn;
	ProcessInfoRec	info;
	OSErr	anErr;
	
	anErr = GetCurrentProcess(&thepsn);
	info.processInfoLength = sizeof(info);
	info.processName = nil;
	info.processAppSpec = nil;
	anErr = GetProcessInformation(&thepsn, &info);
	return info.processSignature;
}

static OSErr GetProcessByType (OSType theID, ProcessSerialNumber* thepsn)
{	
	ProcessInfoRec	info;
	OSErr	anErr;
	
	thepsn->highLongOfPSN = 0;
	thepsn->lowLongOfPSN = kNoProcess;
	anErr = GetNextProcess(thepsn);
	do
	{
		info.processInfoLength = sizeof(info);
		info.processName = nil;
		info.processAppSpec = nil;
		anErr = GetProcessInformation(thepsn, &info);
		if ((anErr == noErr) && (theID == info.processSignature))
		{
			return noErr;
		}
		
	}
	while (GetNextProcess(thepsn)==noErr);
	return -1;
}

static OSType GetBrowserCreator( void )
{
	long	tempsize;
	ICAttr	tempattr=0;
	ICAppSpec	sICAppSpec;
	ICError		theerr;
	Str255		pasKey = "\pHelperhttp";
	
	tempsize = sizeof(sICAppSpec);
	theerr = ICGetPref (ginst, pasKey,&tempattr,(Ptr)(&sICAppSpec),&tempsize);
	// the creator is in sICAppSpec.fCreator
	
	if (theerr != noErr)
	{
		return 0;
	}
	return sICAppSpec.fCreator;

}

void	InitWHandler( void )
{
	ICError	theerr;
	Handle	h;
	ProcessSerialNumber thepsn;
	
	InitjGNEProcLib();
	
	gOurGlobals = (sGullDataPtr) NewPtrSysClear(sizeof(sGullData));
	if (!gOurGlobals)
	{
		DebugStr("\pCould not allocate globals!!!");
		ExitToShell();
	}
	
	theerr = ICStart(&ginst, 'MHck');
	theerr = ICFindConfigFile (ginst, 0 ,nil);
	gOurGlobals->gIHavePatched = false;
	HookjGNE((long)&CalledHandleAnEvent, (long)gOurGlobals);
	
	gOurGlobals->gBrowserCreator = GetBrowserCreator();
	if (gOurGlobals->gBrowserCreator)
	{
		theerr = LaunchAppBySig(gOurGlobals->gBrowserCreator, &thepsn);
	}
	
}

void	CloseWHandler ( void )
{
	OSErr	anErr;
	
	UnHookjGNE();
	DisposePtr((Ptr)gOurGlobals);
	
	ICStop(ginst);
}

static void HandleMenu(short tempval, sGullDataPtr	gGlobalsPtr)
{
	if (tempval==1)
	{
		DebugStr("\pCannot add bookmarks yet");
	}
	else if (tempval==2)
	{
		DebugStr("\pCannot add comments yet");
	}
	else if (tempval>3)
	{
		gGlobalsPtr->whichitem=tempval-3;
		GetURLInfo(gGlobalsPtr);
		gGlobalsPtr->TimeToRun = true;
	}
	
}

static void KillThisRoutine(void) // This isn't really used as a routine, just
{
	long	x = 0;	//as some memory I can overwrite
}

static sGullDataPtr* WhereToGo( void )
{
	return (sGullDataPtr*)(&KillThisRoutine);
}

static sGullDataPtr	GetMyStorage(void)
{
	sGullDataPtr* myptr = WhereToGo();
	return *myptr;
}

static void SaveMyStorage(sGullDataPtr	gGlobalsPtr)
{
	sGullDataPtr* myptr = WhereToGo();
	*myptr = gGlobalsPtr;
}

static	pascal long MyMenuKey( short ch)
{
	long	tempval;
	sGullDataPtr	gGlobalsPtr=GetMyStorage();
	
	tempval = (gGlobalsPtr->SavedMenuKey)(ch);
	if (HiWord(tempval)==gGlobalsPtr->mymenuID)
	{
		HandleMenu(LoWord(tempval), gGlobalsPtr);
		tempval = 0;
	}
	return tempval;
}


static	pascal long MyMenuSelect( Point startpoint)
{
	long	tempval;
	sGullDataPtr	gGlobalsPtr=GetMyStorage();
	
	tempval = (gGlobalsPtr->SavedMenuSelect)(startpoint);
	if (HiWord(tempval)==gGlobalsPtr->mymenuID)
	{
		HandleMenu(LoWord(tempval), gGlobalsPtr);
		tempval = 0;
	}
	return tempval;
}

void GetURLInfo(sGullDataPtr	gGlobalsPtr)
{
	OSErr			err;
	AEAddressDesc	aead;
	AppleEvent		ae;
	AppleEvent		pAeReply;
	unsigned long	templong;
	OSType			tempID;
	long			thesize;
	OSType			typeCode;
	Str255			tempstr;
	OSErr			anErr;
	long			whichURL;
	GrafPtr			tempport;
	
	//	Create the address discriptor from the identifier
	tempID = 'TSLA';
	
	err = AECreateDesc ( typeApplSignature, &tempID,
		sizeof( tempID ), &aead );
	if ( noErr != err ) return;	
	
	//	Create the NewUserAccount AppleEvent
	err = AECreateAppleEvent ( 'MHck', 'GtUr', &aead,
		kAutoGenerateReturnID, kAnyTransactionID, &ae );
	AEDisposeDesc ( &aead );
	if ( noErr != err )
	{	
		AEDisposeDesc ( &ae );
		return;
	}
	templong = gGlobalsPtr->whichitem;
	err = AEPutParamPtr( &ae, '----', typeLongInteger, (const void*)&templong, sizeof(templong) );
	
	pAeReply.dataHandle = nil ;
	
	//	Send the AppleEvent and wait up to one second for a reply.
	err = AESend ( &ae, &pAeReply,  kAEWaitReply,
		kAENormalPriority, kAEDefaultTimeout, nil, nil );
	
	anErr = AEGetParamPtr(&pAeReply, 'tCnt', typeLongInteger, &typeCode,
		&templong, sizeof(templong), &thesize);
	if (anErr==noErr)
	{
		gGlobalsPtr->numberofitems = templong;
	}
	else
	{
		gGlobalsPtr->numberofitems = 0;
	}
	gGlobalsPtr->whichitem ++;
	
	anErr = AEGetParamPtr(&pAeReply, 'URL ', typeChar, &typeCode,
		&tempstr[1], 255, &thesize);
	if (anErr!=noErr)
	{
		thesize = 0;
	}
	tempstr[0]=thesize;
	PLstrcpy(gGlobalsPtr->sURL, tempstr);
	anErr = AEGetParamPtr(&pAeReply, 'Comm', typeChar, &typeCode,
		&tempstr[1], 255, &thesize);
	if (anErr!=noErr)
	{
		thesize = 0;
	}
	tempstr[0]=thesize;
	PLstrcpy(gGlobalsPtr->sComment, tempstr);
	
	anErr = AEGetParamPtr(&pAeReply, 'Titl', typeChar, &typeCode,
		&tempstr[1], 255, &thesize);
	if (anErr!=noErr)
	{
		thesize = 0;
	}
	tempstr[0]=thesize;
	PLstrcpy(gGlobalsPtr->sTitle, tempstr);
}

static void PatchUsIn( sGullDataPtr	gGlobalsPtr)
{
	SaveMyStorage(gGlobalsPtr);
	
	gGlobalsPtr->SavedMenuKey = (MKCaller)GetToolboxTrapAddress(_MenuKey);
	gGlobalsPtr->SavedMenuSelect = (MSCaller)GetToolboxTrapAddress(_MenuSelect);
	
	SetToolboxTrapAddress((UniversalProcPtr) MyMenuKey , _MenuKey);
	SetToolboxTrapAddress((UniversalProcPtr)(MyMenuSelect), _MenuSelect);	
}

static void MakeOurMenu( sGullDataPtr	gGlobalsPtr)
{
	MenuHandle	themenu;
	Str255 tempstr = "\pX";
	long	i;
	
	gGlobalsPtr->TimeToRun = false;
	
	gGlobalsPtr->mymenuID = 32767;
	themenu = NewMenu(gGlobalsPtr->mymenuID, "\pWebArranger");
	AppendMenu(themenu, "\pAdd Bookmark;Get Comment;(-");
	
	gGlobalsPtr->whichitem = 1;
	gGlobalsPtr->numberofitems = 2;
	do
	{
		GetURLInfo(gGlobalsPtr);
		if (gGlobalsPtr->sTitle[0])
		{
			PLstrcpy(tempstr,gGlobalsPtr->sTitle);
		}
		else
		{
			PLstrcpy(tempstr,gGlobalsPtr->sURL);
		}
		AppendMenu(themenu, "\px");
		SetMenuItemText(themenu, CountMItems(themenu), tempstr);
	}
	while (gGlobalsPtr->whichitem <= gGlobalsPtr->numberofitems);
	
	InsertMenu(themenu, 0);
	DrawMenuBar();
	
}

void PollWHandler (Point	where)
{
	OSErr	anErr;
	OSType	theID;
	unsigned long	now;
	long selStart;
	long selEnd;
	ICError	theerr;
	Str31	NilStr="\p";
	GrafPtr	tempport;
	
	if (gOurGlobals->TimeToRun)
	{
		gOurGlobals->TimeToRun = false;
		selStart = 0; selEnd = gOurGlobals->sURL[0];
		theerr = ICLaunchURL(ginst, NilStr, (char*)(&gOurGlobals->sURL[1]),
					gOurGlobals->sURL[0], &selStart, &selEnd);
				
	}
}

pascal Boolean	CalledHandleAnEvent(EventRecord* event, sGullDataPtr	gGlobalsPtr)
{
	short		part, err;
	WindowPtr	window;
	Boolean		hit;
	char		key;
	Point		aPoint;
	Rect		temprect;
	MenuHandle	mh;

	if (GetCurrentSignature()==gGlobalsPtr->gBrowserCreator)
	{
		if (gGlobalsPtr->gIHavePatched)
		{
			if (gGlobalsPtr->gTimeToBuildMenu)
			{
				gGlobalsPtr->gTimeToBuildMenu = false;
				mh = GetMenuHandle(gGlobalsPtr->mymenuID);
				if (mh)
				{
					DeleteMenu(gGlobalsPtr->mymenuID);
					DisposeMenu(mh);
					DrawMenuBar();
				}
				MakeOurMenu(gGlobalsPtr);
			}
		}
		else
		{
			
			gGlobalsPtr->gIHavePatched = true;
			gGlobalsPtr->gTimeToBuildMenu = false;
			PatchUsIn(gGlobalsPtr);
			MakeOurMenu(gGlobalsPtr);
		}
	}
	else
	{
		gGlobalsPtr->gTimeToBuildMenu = true;
	}
	return false;
}

